'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactJss = require('react-jss');

var _reactJss2 = _interopRequireDefault(_reactJss);

var _reactMotion = require('react-motion');

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ArrowRight = function ArrowRight(props) {
  return _react2.default.createElement(
    'svg',
    props,
    _react2.default.createElement('path', {
      d: 'M4.719 6.28c.285 0 .475.38.238.617l-.475.475c-.285.285-.285.665 0 .95l.951.95c.286.286.666.286.95.001l3.799-3.798c.285-.285.285-.665 0-.95L6.378.722c-.286-.286-.666-.286-.95 0l-.95.949c-.285.285-.285.665 0 .95l.476.475c.19.19.095.57-.238.618l-3.8-.002a.649.649 0 0 0-.665.664v1.33c.001.286.286.57.666.571l3.801.002z',
      fill: '#EF6E4F',
      fillRule: 'evenodd'
    })
  );
};

ArrowRight.defaultProps = {
  width: '11',
  height: '10',
  viewBox: '0 0 11 10',
  xmlns: 'http://www.w3.org/2000/svg'
};

var ArrowLeft = function ArrowLeft(props) {
  return _react2.default.createElement(
    'svg',
    props,
    _react2.default.createElement('path', {
      d: 'M6.281 6.28c-.285 0-.475.38-.238.617l.475.475c.285.285.285.665 0 .95l-.951.95c-.286.286-.666.286-.95.001L.817 5.475c-.285-.285-.285-.665 0-.95L4.622.722c.286-.286.666-.286.95 0l.95.949c.285.285.285.665 0 .95l-.476.475c-.19.19-.095.57.238.618l3.8-.002c.38 0 .665.284.665.664v1.33c-.001.286-.286.57-.666.571L6.28 6.28z',
      fill: '#3B4D8D',
      fillRule: 'evenodd',
      opacity: '.8'
    })
  );
};

ArrowLeft.defaultProps = {
  width: '11',
  height: '10',
  viewBox: '0 0 11 10',
  xmlns: 'http://www.w3.org/2000/svg'
};

var IconActiveOval = function IconActiveOval(props) {
  return _react2.default.createElement(
    'svg',
    props,
    _react2.default.createElement('rect', {
      width: '20',
      height: '6',
      rx: '3',
      fill: '#EF6E4F',
      fillRule: 'evenodd'
    })
  );
};

IconActiveOval.defaultProps = {
  width: '20',
  height: '6',
  viewBox: '0 0 20 6',
  xmlns: 'http://www.w3.org/2000/svg'
};

var IconInactiveCircle = function IconInactiveCircle(props) {
  return _react2.default.createElement(
    'svg',
    props,
    _react2.default.createElement('circle', {
      cx: '39',
      cy: '3',
      r: '3',
      transform: 'translate(-36)',
      fill: '#3B4D8D',
      fillRule: 'evenodd'
    })
  );
};

IconInactiveCircle.defaultProps = {
  width: '6',
  height: '6',
  viewBox: '0 0 6 6',
  xmlns: 'http://www.w3.org/2000/svg'
};

var IconClose = function IconClose(props) {
  return _react2.default.createElement(
    'svg',
    props,
    _react2.default.createElement('path', {
      d: 'M10.85 9.612L7.136 5.899l3.712-3.712a.878.878 0 0 0 0-1.237.878.878 0 0 0-1.237 0L5.899 4.662 2.187.95A.878.878 0 0 0 .95.95a.878.878 0 0 0 0 1.237L4.662 5.9.95 9.612a.878.878 0 0 0 0 1.237c.34.34.897.34 1.237 0L5.9 7.137l3.713 3.712c.34.34.897.34 1.237 0a.878.878 0 0 0 0-1.237z',
      fill: '#6274A6',
      fillRule: 'nonzero'
    })
  );
};

IconClose.defaultProps = {
  width: '12',
  height: '12',
  viewBox: '0 0 12 12',
  xmlns: 'http://www.w3.org/2000/svg'
};


var decorate = (0, _reactJss2.default)({
  root: {
    background: 'lightgrey',
    position: 'fixed',
    width: 400,
    zIndex: 100,
    top: 0,
    left: 0
  },
  corner: {
    transform: 'rotate(135deg)',
    width: 10,
    height: 10,
    position: 'absolute',
    bottom: -4,
    right: 'calc(50% - 5px)',
    background: 'lightgrey'
  },
  content: {
    color: 'black',
    fontSize: 12,
    padding: [[15, 30, 15, 30]],
    borderBottom: '1px solid rgba(200, 200, 200, 0.1)',
    whiteSpace: 'pre-wrap'
  },
  controls: {
    display: 'flex',
    justifyContent: 'space-between',
    padding: [[10, 20, 10, 20]],
    alignItems: 'center'
  },
  pagination: {
    minHeight: 1,
    flex: 1,
    display: 'flex',
    justifyContent: 'center'
  },
  paginationItem: {
    padding: [[0, 2]],
    cursor: 'pointer',
    boxSizing: 'content-box'
  },
  paginationItemActive: {
    cursor: 'default'
  },
  prev: {
    cursor: 'pointer',
    padding: 5,
    height: 10,
    marginTop: -5,
    boxSizing: 'content-box'
  },
  next: {
    cursor: 'pointer',
    padding: 5,
    height: 10,
    marginTop: -5,
    boxSizing: 'content-box'
  },
  finish: {
    color: 'black',
    cursor: 'pointer',
    fontSize: 14,
    '&:hover': {
      color: 'rgba(255, 255, 255, 1)'
    }
  },
  iconClose: {
    position: 'absolute',
    padding: 5,
    top: 10,
    right: 10,
    cursor: 'pointer',
    boxSizing: 'content-box'
  },
  stepsInfo: {
    fontSize: 14,
    marginTop: 20,
    marginLeft: 30
  },
  invisible: {
    visibility: 'hidden'
  }
});

var getPos = function getPos(_ref) {
  var editor = _ref.editor,
      tooltip = _ref.tooltip,
      options = _ref.options;

  var _options$pos$split$ma = options.pos.split(':').map(function (one) {
    return parseInt(one, 10);
  }),
      _options$pos$split$ma2 = (0, _slicedToArray3.default)(_options$pos$split$ma, 2),
      line = _options$pos$split$ma2[0],
      ch = _options$pos$split$ma2[1];

  var coords = editor.charCoords({ line: line, ch: ch });

  var viewportLeft = window.pageXOffset - document.documentElement.clientLeft;
  var viewportWidth = document.documentElement.clientWidth;

  var width = 400;

  var left = Math.min(viewportWidth - width, Math.max(0, coords.left - viewportLeft - width / 2));
  var top = Math.max(0, coords.top - tooltip.scrollHeight);

  return { left: left, top: top };
};

var Tooltip = function (_React$Component) {
  (0, _inherits3.default)(Tooltip, _React$Component);

  function Tooltip() {
    var _ref2;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, Tooltip);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref2 = Tooltip.__proto__ || Object.getPrototypeOf(Tooltip)).call.apply(_ref2, [this].concat(args))), _this), _this.ref = _react2.default.createRef(), _this.state = {
      stopping: false,
      finishing: false,
      appearing: true,
      fromPos: {
        left: 0,
        top: 0
      },
      pos: {
        left: 0,
        top: 0
      }
    }, _this.updatePos = function () {
      if (!_this.ref.current) {
        return;
      }

      var pos = _this.state.pos;


      var nextPos = getPos({
        editor: _this.props.editor,
        tooltip: _this.ref.current,
        options: _this.props.options
      });

      if (pos.left === nextPos.left && pos.top === nextPos.top) {
        return;
      }

      _this.setState({
        stopping: false,
        finishing: false,
        appearing: true,
        fromPos: pos,
        pos: nextPos
      });
    }, _this.handleStop = function () {
      _this.setState({
        stopping: true
      });
    }, _this.handleFinish = function () {
      _this.setState({
        finishing: true
      });
    }, _this.handleReady = function () {
      _this.setState({
        appearing: false
      });
    }, _this.getResultClasses = function () {
      var _this$props = _this.props,
          classes = _this$props.classes,
          customClasses = _this$props.customClasses;

      if (!customClasses) {
        return classes;
      }

      var result = {};
      Object.keys(classes).forEach(function (key) {
        result[key] = (0, _classnames2.default)(classes[key], customClasses[key]);
      });

      return result;
    }, _this.handleNext = function () {
      _this.props.onActionChange(_this.props.index + 1);
    }, _this.handlePrev = function () {
      _this.props.onActionChange(_this.props.index - 1);
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(Tooltip, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.updatePos();
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      this.updatePos();
    }
  }, {
    key: 'render',
    value: function render() {
      if (this.state.stopping || this.state.finishing) {
        return this.renderDisapearance();
      }

      if (this.state.appearing) {
        return this.renderAppearance();
      }

      return this.renderTooltip(this.state.pos);
    }
  }, {
    key: 'renderAppearance',
    value: function renderAppearance() {
      var _this2 = this;

      var _state = this.state,
          pos = _state.pos,
          fromPos = _state.fromPos;


      return _react2.default.createElement(
        _reactMotion.Motion,
        {
          defaultStyle: {
            opacity: fromPos.left ? 1 : 0,
            left: fromPos.left,
            top: fromPos.top
          },
          style: {
            opacity: (0, _reactMotion.spring)(1),
            left: (0, _reactMotion.spring)(pos.left),
            top: (0, _reactMotion.spring)(pos.top)
          },
          onRest: this.handleReady
        },
        function (_ref3) {
          var opacity = _ref3.opacity,
              left = _ref3.left,
              top = _ref3.top;
          return _this2.renderTooltip({
            opacity: opacity,
            transform: 'translate3d(' + left + 'px, ' + top + 'px, 0)'
          });
        }
      );
    }
  }, {
    key: 'renderDisapearance',
    value: function renderDisapearance() {
      var _this3 = this;

      var pos = this.state.pos;


      return _react2.default.createElement(
        _reactMotion.Motion,
        { defaultStyle: { opacity: 1 }, style: { opacity: (0, _reactMotion.spring)(0) }, onRest: this.state.stopping ? this.props.onStop : this.props.onFinish },
        function (_ref4) {
          var opacity = _ref4.opacity;
          return _this3.renderTooltip({
            opacity: opacity,
            left: pos.left,
            top: pos.top
          });
        }
      );
    }
  }, {
    key: 'renderTooltip',
    value: function renderTooltip(style) {
      var _props = this.props,
          total = _props.total,
          index = _props.index,
          options = _props.options;

      var classes = this.getResultClasses();

      return _react2.default.createElement(
        'div',
        { className: (0, _classnames2.default)(classes.root, classes.defaultRoot), style: style, ref: this.ref },
        _react2.default.createElement(
          'div',
          { className: (0, _classnames2.default)(classes.stepsInfo, total <= 1 && classes.invisible) },
          index + 1,
          '/',
          total
        ),
        _react2.default.createElement(
          'div',
          { className: classes.content },
          options.text
        ),
        _react2.default.createElement(IconClose, { className: classes.iconClose, onClick: this.handleStop }),
        _react2.default.createElement(
          'div',
          { className: classes.controls },
          index > 0 && _react2.default.createElement(ArrowLeft, { className: classes.prev, onClick: this.handlePrev }),
          this.renderPagination(),
          index < total - 1 ? _react2.default.createElement(ArrowRight, { className: classes.next, onClick: this.handleNext }) : _react2.default.createElement(
            'span',
            { className: classes.finish, onClick: this.handleFinish },
            'Finish'
          )
        ),
        _react2.default.createElement('div', { className: classes.corner })
      );
    }
  }, {
    key: 'renderPagination',
    value: function renderPagination() {
      var _this4 = this;

      var _props2 = this.props,
          index = _props2.index,
          total = _props2.total;

      var items = Array(total).fill(0);
      var classes = this.getResultClasses();

      return _react2.default.createElement(
        'div',
        { className: (0, _classnames2.default)(classes.pagination, total <= 1 && classes.invisible) },
        items.map(function (one, i) {
          var Component = i === index ? IconActiveOval : IconInactiveCircle;
          return _react2.default.createElement(Component, {
            key: i,
            onClick: i === index ? null : function () {
              return _this4.props.onActionChange(i);
            },
            className: (0, _classnames2.default)(classes.paginationItem, i === index && classes.paginationItemActive)
          });
        })
      );
    }
  }]);
  return Tooltip;
}(_react2.default.Component);

exports.default = decorate(Tooltip);